import axios from 'axios'
import { MessageBox, Message } from 'element-ui'
import store from '@/store'
import { getToken } from '@/utils/auth'
import qs from 'qs'
// create an axios instance
const service = axios.create({
  baseURL: process.env.VUE_APP_BASE_API, // url = base url + request url
  // withCredentials: true, // send cookies when cross-domain requests
  timeout: 30000 // request timeout
})

// request interceptor
service.interceptors.request.use(
  config => {
    // do something before request is sent

 // console.log("config1",config);
    if(store.getters.token){
      // config.headers['token']=store.getters.token;

      config.data = {
          ...config.data,
          token: store.getters.token
      }
       // config.headers={
       //   ...{
       //     'Accept':'application/json, text/plain, */*',
       //     'Content-Type':'application/x-www-form-urlencoded',
       //     'token':store.getters.token
       //   }
       // }
    }
    // console.log("config2",config);
    config.data = qs.stringify(config.data);
    // console.log("config2",config);
    // config.headers={
    //  'Content-Type': 'multipart/form-data',
    //  'token':store.getters.token,
    // }



    return config
  },
  error => {
    return Promise.reject(error)
  }
)

// response interceptor
service.interceptors.response.use(
  /**
   * If you want to get http information such as headers or status
   * Please return  response => response
  */

  /**
   * Determine the request status by custom code
   * Here is just an example
   * You can also judge the status by HTTP Status Code
   */
  response => {
    const res = response.data
    // if the custom code is not 20000, it is judged as an error.
    if (Number(res.status) !== 200) {
      Message({
        message: res.errMsg ||res.message,// 'Error'||
        type: 'error',
        duration: 5 * 1000
      })
    } else {
      return res
    }
  },
  error => {
    // console.log('err' + error) // for debug
    // Message({
    //   message: error.message,
    //   type: 'error',
    //   duration: 5 * 1000
    // })
    return Promise.reject(error)
  }
)

export default service
